Bug 522477 - nss-config --libs nss has wrong output
Summary: nss-config --libs nss has wrong output
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: nss
Version: rawhide
Hardware: All
OS: Linux
urgent
urgent
Target Milestone: ---
Assignee: Elio Maldonado Batiz
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-09-10 12:55 UTC by Jan Horak
Modified: 2009-10-05 18:38 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-10-05 18:38:32 UTC
Type: ---


Attachments (Terms of Use)
suggested changes to build with the split nss (2.23 KB, patch)
2009-09-10 15:57 UTC, Elio Maldonado Batiz
no flags Details | Diff

Description Jan Horak 2009-09-10 12:55:59 UTC
Description of problem:
Unable to compile latest xulrunner security update due to wrong nss-config  output. 
Instead of:
-Wl,-rpath-link,/usr/lib64 -L/usr/lib64 -lssl3 -lsmime3 -lnss3 -lnssutil3
it shows:
-Wl,/usr/lib64 -L/usr/lib64 -lssl3 -lsmime3 -lnss3

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1. run on rawhide: nss-config --libs nss 
2.
3.
  
Actual results:
-Wl,/usr/lib64 -L/usr/lib64 -lssl3 -lsmime3 -lnss3

Expected results:
-Wl,-rpath-link,/usr/lib64 -L/usr/lib64 -lssl3 -lsmime3 -lnss3 -lnssutil3

Additional info:

Comment 1 Elio Maldonado Batiz 2009-09-10 15:57:47 UTC
Created attachment 360527 [details]
suggested changes to build with the split nss

These are possible changes to build against the nss after the split into nss, nss-softokn, and nss-util. I may have made more changes that are absolutely required

Comment 2 Elio Maldonado Batiz 2009-09-10 16:12:09 UTC
The problem is that nssutil3.so library is now provided by the nss-util
package, other libraries are now provided by nss-softokn.

Executing nss-softokn-config --libs freebl softokn shows
-Wl,/usr/lib -L/usr/lib -lfreebl3 -lnssdbm3 -lnsoftokn3
and executing nsss-util-config --libs nssutil shows
-Wl, -L -lnssutil3

For Fedora 12 we are splitting two new packages, nss-softoken and nss-util, see
https://fedoraproject.org/wiki/Features/SplitSoftoknFromNSS

The attachment suggest changes that could be made to xulrunner expanding
BuildRequires to include nss-softokn and nss-util. Based on these cahnges I
tried a scratch build
http://koji.fedoraproject.org/koji/taskinfo?taskID=1668326

It failed but I suspect for reasons other than the nss split.

Comment 3 Christopher Aillon 2009-09-10 17:11:09 UTC
Related, why are we using nss-config and not pkg-config?

Comment 4 Christopher Aillon 2009-09-10 17:16:39 UTC
Comment on attachment 360527 [details]
suggested changes to build with the split nss

>Index: xulrunner-mozconfig

>+ac_add_options --with-system-nss-util
>+ac_add_options --with-system-nss-softokn

I looked in mozilla/configure.in and I do not see these options there.  While the softokn and util libs/headers may be present on the build system, xulrunner/firefox do not know how to use them.

Comment 5 Jan Horak 2009-09-10 21:02:35 UTC
(In reply to comment #2)
> The problem is that nssutil3.so library is now provided by the nss-util
> package, other libraries are now provided by nss-softokn.
> 
> Executing nss-softokn-config --libs freebl softokn shows
> -Wl,/usr/lib -L/usr/lib -lfreebl3 -lnssdbm3 -lnsoftokn3

This '-Wl,/usr/lib' is also wrong. Gcc handle it as a -l/usr/lib and reports that /usr/lib is a directory and not a file (dynamic linked library). On the other hand this '-Wl,-rpath-link,/usr/lib' is ok.

Comment 6 Elio Maldonado Batiz 2009-09-10 21:20:25 UTC
The use of -rpath-link is flagged as an error by rplint and after asking around I removed it. I could (1) restore it (in nss, nss-softojkn, and nss-util) and make an official build or (2) I could restore it locally on my system, make scratch builds for the xulrunner build to try. 

Jan, could you build xulrunner against my scratch builds for now until we work out the changes on my side and your side that are actually needed?

Comment 7 Christopher Aillon 2009-09-10 22:06:53 UTC
Elio, to sum up the situation:

  BEFORE: rpmlint complained, but things could build against nss
  AFTER:  rpmlint is happy, but things cannot build against nss because of
          invalid link lines provided by nss-config

The current situation is a bad tradeoff, especially because it is preventing security updates from being built.  There is no reason why fixing a linting issue should be cause for leaving packages in a broken state.

I think the best thing to do is to revert the rpath change for now, and then we can figure out what else needs to be done.

Comment 8 Elio Maldonado Batiz 2009-09-10 23:10:03 UTC
I agree, I am going to revert some of my changes. Xulrunners' build system shouldn't have to change because of of split and other cleaning up. I'll restore the -rpath-link and until I find out how to use some form chaining information with pkgconfig I'm restoring nssutil to the list for nss. Give me at least a couple of hours as I plan to do a chained build.

Comment 9 Elio Maldonado Batiz 2009-09-11 03:56:32 UTC
Did the chain build and after the dist-12 repo was rebuilt I launched an xulrunner scratch build http://koji.fedoraproject.org/koji/taskinfo?taskID=1669735
which should be finished by the time you read this.

Comment 10 Christopher Aillon 2009-09-11 06:48:44 UTC
Thanks, it looks like it built successfully: http://koji.fedoraproject.org/koji/buildinfo?buildID=131150

Comment 11 Adam Williamson 2009-10-05 18:06:12 UTC
this is fixed now, yes?

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 12 Elio Maldonado Batiz 2009-10-05 18:31:18 UTC
(In reply to comment #11) Yes, it is fixed.

Comment 13 Adam Williamson 2009-10-05 18:38:32 UTC
let's close, then.

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers


Note You need to log in before you can comment on or make changes to this bug.